Subject: Mails about CPlane GSMP modifications

From: Balaji Srinivasan <[email-masked]>
Date: Thu, 30 Dec 1999 11:57:10 -0800 (PST)

Hi Everyone,
	As was requested at the WG meeting in Washington, I am sending
out individual mails for each of our proposals that we made to enhance
GSMP. This mail deals with making PDU parsing easier.
The original draft can be obtained at
http://www.cplane.com/docs/draft-sydir-cplane-gsmp-enhancements-00.txt

Our proposal is to modify the header of each message (except the adjacency
messages) to have a label length and a sub-message number field.

  0                   1                   2                   3
  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |    Version    | Message Type  |    Result     |     Code      |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  | Partition ID  |           Transaction Identifier              |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |           SubMessage Number   |           Length              |
  |-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |                                                               |
  ~                         GSMP Message                          ~
  |                                                               |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Apart from some terminology difference, the only difference between 
the above format and the one that we submitted as a draft is that 
we have removed the I flag that indicated whether this was the 
first sub-message of the message. This is accomplished by setting
the Result field to "more". If the result field is set to more
then the SubMessage number field indicates the total number of sub-messages
that this message has. Otherwise it indicates the sequence number
of the sub-message.

NOTE: This increases the add branch message for ATM connections to
more than 1 cell length. We feel that it is a small price to pay for
the generality and other advantages that this format provides (especially 
since the problem arises only when its a software SAR). It is
also our opinion that CRC checking of the PDU will occupy more time than
the reassembly, so the increase to two cells will not affect the processing
requirements too much. Any switch vendors care to comment?

thanks 
balaji

Balaji Srinivasan
[email-masked]
Control Plane Technologies